# coding: utf-8
"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 3.0.0
    Generated by: https://konfigthis.com
"""

from humanloop.configuration import Configuration
from humanloop.api_client import ApiClient
from humanloop.apis.tags.experiments_api import ExperimentsApi
from humanloop.apis.tags.feedback_api import FeedbackApi
from humanloop.apis.tags.generate_api import GenerateApi
from humanloop.apis.tags.logs_api import LogsApi
from humanloop.apis.tags.model_configs_api import ModelConfigsApi
from humanloop.apis.tags.projects_api import ProjectsApi


class Humanloop:

    def __init__(self, configuration: Configuration = None, **kwargs):
        if (len(kwargs) > 0):
            configuration = Configuration(**kwargs)
        if (configuration is None):
            raise Exception("configuration is required")
        api_client = ApiClient(configuration)
        self.experiments = ExperimentsApi(api_client)
        self.feedback_api = FeedbackApi(api_client)
        self.generate_api = GenerateApi(api_client)
        self.logs_api = LogsApi(api_client)
        self.model_configs = ModelConfigsApi(api_client)
        self.projects = ProjectsApi(api_client)

    def feedback(self, *args, **kwargs):
        return self.feedback_api.submit(*args, **kwargs)

    def chat(self, *args, **kwargs):
        return self.generate_api.chat(*args, **kwargs)

    def generate(self, *args, **kwargs):
        return self.generate_api.generate(*args, **kwargs)

    def log(self, *args, **kwargs):
        return self.logs_api.log(*args, **kwargs)
